/************************************************
* PR.C - a simple print file utility			*
*												*
* 900424 MCMason - written for MSC 5.1			*
************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "tab.h"

#define MAXLINE 250
#define OUTDEV  stdout	/* output device */

char in[MAXLINE], out[4*MAXLINE];

void main(int argc, char *argv[])
	{
	int i,tmp;
	FILE *f;

	setTab(4);			/* DEFAULT VALUE */
	for (i=1; i<argc; i++)
		if (argv[i][0]=='-')	/* Change tabs?	*/
			{					/* Yes */
			tmp = atoi(argv[i]+1);
			if (tmp > 0)
				setTab(tmp);
			}
		else
			{					/* No, print file*/
			if ((f=fopen(argv[i],"r")) == NULL)
				fprintf(stderr,"Can't open %s\n",
						argv[i]);
			else
				{
				fprintf(stderr,"Printing %s\n",
						argv[i]);
				for (;fgets(in,MAXLINE,f)!=NULL;)
					{
					detab(in,out);
					fputs(out,OUTDEV);
					fputc('\r',OUTDEV);
					}
				fputc('\014',OUTDEV);
				}
			}
	}
