/************************************************
* VARARG.C - variable argument function demo	*
*												*
* 900424 MCMason - written for MSC 5.1			*
************************************************/

#include <stdio.h>
#include <stdarg.h>	/* Needed for variable args!*/
#include <limits.h>	/* INT_MIN, LONG_MIN */
#include <float.h>	/* DBL_MIN */

#define INT		1	/* Flag for 'INTEGER' type	*/
#define LONG	2	/* Flag for 'LONG' type		*/
#define	DBL		3	/* Flag for 'DOUBLE' type	*/

/************************************************
* max - print the largest number passed in		*
*												*
* INP:	n   - number of items passed in			*
*		t   - type of item passed in			*
*		... - the numbers to check				*
************************************************/
void max(int n, int t, ...)
	{
	va_list x;
	int		i, mi, j;
	long	l, ml;
	double	d, md;

	va_start(x, t);

	switch (t)
		{
		case INT:	mi=INT_MIN;
					for (j=0; j<n; j++)
						{
						i=va_arg(x,int);
						if (i>mi)	mi=i;
						}
					printf("Max int: %d\n",mi);
					break;

		case LONG:	ml=LONG_MIN;
					for (j=0; j<n; j++)
						{
						l=va_arg(x,long);
						if (l>ml)	ml=l;
						}
					printf("Max long: %ld\n",ml);
					break;

		case DBL:	md=DBL_MIN;
					for (j=0; j<n; j++)
						{
						d=va_arg(x,double);
						if (d>md)	md=d;
						}
					printf("Max double: %f\n",md);
					break;
		}
	va_end(x);
	}

/************************************************
* main - call max with different numbers and	*
* types, to demonstrate that it works.			*
************************************************/
void main(void)
	{
	/* Integer */
	max(5,INT,25,10,13,30,20);

	/* Long */
	max(6,LONG,19473643,48274927,93747267,
			   56828472,99472674,87433675);

	/* Double */
	max(7,DBL,3.141592,2.71828,1e-20,2.73153e1,
			  28.0,56.89e-4,-9.9e99);

	/* Incorrect number of arguments */
	max(10,DBL,1.0,2.0,3.0);
	}
